#include <deque>
#include <mutex>

template< typename T >
class Naive {
    std::deque< T > _queue;
    std::mutex _m;
public:
    void enqueue( T x ) {
        std::unique_lock< std::mutex > lock( _m );
        _queue.push_back( x );
    }

    T dequeue() {
        std::unique_lock< std::mutex > lock( _m );
        T x = _queue.front();
        _queue.pop_front();
        return x;
    }

    bool empty() {
        std::unique_lock< std::mutex > lock( _m );
        return _queue.empty();
    }
};

