
template< int size = 512 >
struct Ring {

    template< typename T >
    struct Q {
        volatile int reader;
        T q[ size ];
        volatile int writer;

        void enqueue( T x ) {
            while ( (writer + 1) % size == reader ); // full; need to wait
            q[ writer ] = x;
            writer = (writer + 1) % size;
        }

        T dequeue() {
            T x = q[ reader ];
            reader = (reader + 1) % size;
            return x;
        }

        bool empty() {
            return reader == writer;
        }

        Q() : reader( 0 ), writer( 0 ) {}
    };
};

